<?php

class RedPayValidationModuleFrontController extends ModuleFrontController
{
    public function postProcess()
    {
        $cart = $this->context->cart;


        if ($cart->id_customer == 0 || $cart->id_address_delivery == 0 || $cart->id_address_invoice == 0 || !$this->module->active)
            Tools::redirect('index.php?controller=order&step=1');

        // Check that this payment option is still available in case the customer changed his address just before the end of the checkout process
        $authorized = false;

        foreach (Module::getPaymentModules() as $module)
            if ($module['name'] == 'redpay')
            {
                $authorized = true;
                break;
            }

        if (!$authorized) {
            die($this->module->l('This payment method is not available.', 'validation'));
        }

        $customer = new Customer($cart->id_customer);

        if (!Validate::isLoadedObject($customer)){
            Tools::redirect('index.php?controller=order&step=1');
		}else{



		$apiKey = Configuration::get('ApiKey');
		$password = Configuration::get('Password');
		$environment = Configuration::get('Ambiente');

		$url = '';

		if ($environment=='1'){
			$url = 'https://appredpayapiclientmxdev.azurewebsites.net/api/auth/Authenticate';
		}else{
			$url = 'https://api.redpayonline.com/api/auth/Authenticate';
		}

		// Setup request to send json via POST
		$data = array(
		   "UserId" => $apiKey,
		   "Password"=> $password
		);
		$payload = json_encode($data);

		// Create a new cURL resource
		$ch = curl_init($url);

		// Attach encoded JSON string to the POST fields
		curl_setopt($ch, CURLOPT_POSTFIELDS, $payload);

		// Set the content type to application/json
		curl_setopt($ch, CURLOPT_HTTPHEADER, array('Content-Type:application/json'));

		// Return response instead of outputting
		curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);

		curl_setopt($ch, CURLOPT_SSL_VERIFYHOST, 0);
		curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, 0);

		// Execute the POST request
		$response = curl_exec($ch);

		// Close cURL resource
		curl_close($ch);

		 $body = json_decode( $response, true );
 
		 if( $body["message"] == 'Success' ) {


			// API URL
			if ($environment=='1'){
				$url = 'https://appredpayapiclientmxdev.azurewebsites.net/api/Pay/Create';
			}else{
				$url = 'https://api.redpayonline.com/api/Pay/Create';
			}

			// Create a new cURL resource
			$ch = curl_init($url);

			// Setup request to send json via POST
			$data = array(
			   "IdPaymentMethod"=> $_POST[ 'card-type' ] == '03' ? 3 : 2,
				"ReferenceNumber"=>  str_pad($cart->id,10,'0',STR_PAD_LEFT),
				"CardType"=> '0'.$_POST[ 'card-type' ],
				"cardNumber"=> $_POST[ 'card-number' ],
				"cardExpirationMonth"=> $_POST[ 'card-expiry-month' ],
				"cardExpirationYear"=> $_POST[ 'card-expiry-year' ],
				"cvv"=> $_POST[ 'card-cvc' ],
				"Amount"=> (float)$cart->getordertotal(false),
				"Currency"=> 'MXN',
				"FirstName"=> $_POST[ 'firstname' ],
				"LastName"=> $_POST[ 'lastname' ],
				"Email"=> $_POST[ 'email' ],
				"PhoneNumber"=>''
			);
			$payload = json_encode($data);

			// Attach encoded JSON string to the POST fields
			curl_setopt($ch, CURLOPT_POSTFIELDS, $payload);

			 // Set the content type to application/json
			 $authorization = "Authorization: Bearer ".$body["token"]; // Prepare the authorisation token
			 curl_setopt($ch, CURLOPT_HTTPHEADER, array('Content-Type: application/json' , $authorization )); // Inject the token into the header
				  

			// Return response instead of outputting
			curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);


			curl_setopt($ch, CURLOPT_SSL_VERIFYHOST, 0);
			curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, 0);


			// Execute the POST request
			$response = curl_exec($ch);


			// Close cURL resource
			curl_close($ch);

			$body = json_decode( $response, true );
			
			 Tools::redirect($this->context->link->getModuleLink('redpay', '3dsecure', array('payload' => json_encode($body))));
			 
			 //return $result->setData(['response' => 'redirigir', 'payload' => $payload, 'cuerpo' => $body]);
		 }else{
			 Tools::redirect('index.php?controller=order&step=1&message='.$body["message"]);
		 }




		}

    }
}